<script>
	import { layoutData } from '../stores/layoutStore.js';
	import { hapiServerInfoCadences, hapiServerInfo, dataProductInfo, urlsToLoad } from '../stores/dataProductStore.js';
	import PlotElementForm from '../form_sections/PlotElementForm.svelte';
	import Switch from      '../form_components/Switch.svelte';
	import RangeSlider from '../form_components/RangeSlider.svelte';

	export let subplot;
	export let subplot_index;

	let visible = false;

	const setBooleanProperty = function(e, i, property, values) {
		if (e.srcElement.checked) {
			$layoutData.subplots[i][property] = values[true];
		} else {
			$layoutData.subplots[i][property] = values[false];
		}
	}

	const set_ydomain = function(e, i, min_or_max) {
		let value = e.srcElement.value;
		if (min_or_max == 'min') {
			if ($layoutData.subplots[i].scale == "log10") {
				$layoutData.subplots[i].ydomain.default[0] =value;
			} else {
				$layoutData.subplots[i].ydomain.default[0] = value;
			}
		} else {
			if ($layoutData.subplots[i].scale == "log10") {
				$layoutData.subplots[i].ydomain.default[1] = value;
			} else {
				$layoutData.subplots[i].ydomain.default[1] = value;
				if ($layoutData.subplots[i].ydomain.mirror) {
					$layoutData.subplots[i].ydomain.default[0] = -1*value;
				}
			}
		}
	}


</script>

<div on:click={()=>{visible=!visible}}>
	{#if visible}
	<h3><svg style="display: inline-block; float: left; align-self: center; margin-right: 10px;" xmlns="http://www.w3.org/2000/svg" height="24" width="24">
		<path d="m12 15.5 4.5-4.5-1.425-1.4L12 12.675 8.925 9.6 7.5 11Zm0 6.5q-2.075 0-3.9-.788-1.825-.787-3.175-2.137-1.35-1.35-2.137-3.175Q2 14.075 2 12t.788-3.9q.787-1.825 2.137-3.175 1.35-1.35 3.175-2.138Q9.925 2 12 2t3.9.787q1.825.788 3.175 2.138 1.35 1.35 2.137 3.175Q22 9.925 22 12t-.788 3.9q-.787 1.825-2.137 3.175-1.35 1.35-3.175 2.137Q14.075 22 12 22Zm0-2q3.35 0 5.675-2.325Q20 15.35 20 12q0-3.35-2.325-5.675Q15.35 4 12 4 8.65 4 6.325 6.325 4 8.65 4 12q0 3.35 2.325 5.675Q8.65 20 12 20Zm0-8Z"/>
	</svg>Subplot: {subplot.title}</h3>
	{:else}
	<h3><svg style="display: inline-block; float: left; align-self: center; margin-right: 10px;" xmlns="http://www.w3.org/2000/svg" height="24" width="24">
		<path transform="rotate(-90 12 12)" d="m12 15.5 4.5-4.5-1.425-1.4L12 12.675 8.925 9.6 7.5 11Zm0 6.5q-2.075 0-3.9-.788-1.825-.787-3.175-2.137-1.35-1.35-2.137-3.175Q2 14.075 2 12t.788-3.9q.787-1.825 2.137-3.175 1.35-1.35 3.175-2.138Q9.925 2 12 2t3.9.787q1.825.788 3.175 2.138 1.35 1.35 2.137 3.175Q22 9.925 22 12t-.788 3.9q-.787 1.825-2.137 3.175-1.35 1.35-3.175 2.137Q14.075 22 12 22Zm0-2q3.35 0 5.675-2.325Q20 15.35 20 12q0-3.35-2.325-5.675Q15.35 4 12 4 8.65 4 6.325 6.325 4 8.65 4 12q0 3.35 2.325 5.675Q8.65 20 12 20Zm0-8Z"/>
	</svg>Subplot: {subplot.title}</h3>
	{/if}
</div>
{#if visible}
	<Switch titleText="Visibility"
		id="subplot_{subplot.subplot_id}_visible"
		checked={subplot.visible==true}
		onchange={ (e) => { setBooleanProperty(e, subplot_index, 'visible', {true: true, false: false})} }/>
	<Switch titleText="Date/time annotation"
		id="subplot_{subplot.subplot_id}_xaxisannotation"
		checked={subplot.xaxis_annotation=="visible"}
		onchange={(e) => { setBooleanProperty(e, subplot_index, 'xaxis_annotation', {true: 'visible', false: 'hidden'})}}/>

	<RangeSlider titleText="Height" min=30 max=400 step=1 id="subplot_{subplot.subplot_id}_height" bind:value={$layoutData.subplots[subplot_index].height}/>
	<RangeSlider titleText="Top margin" min=0 max=100 step=1 id="subplot_{subplot.subplot_id}_topmargin" bind:value={$layoutData.subplots[subplot_index].margins.top}/>
	<RangeSlider titleText="Bottom margin" min=0 max=100 step=1 id="subplot_{subplot.subplot_id}_bottommargin" bind:value={$layoutData.subplots[subplot_index].margins.bottom}/>

	<!-- <RangeSliderMinMax titleText="Test" min=0 max=100/> -->

	{#if !subplot.ydomain.mirror}
		<RangeSlider titleText="Y-axis min"
					 fill="fillfromright"
					 min={subplot.ydomain.min_range[0]}
					 max={subplot.ydomain.max_range[1]}
					 step={subplot.ydomain.step}
					 id="subplot_{subplot.subplot_id}_yaxismin"
					 value={subplot.ydomain.default[0]}
					 oninput={ (e) => { set_ydomain(e, subplot_index, 'min') } }/>
	{/if}
	<RangeSlider titleText="Y-axis max"
		 fill="fillfromleft"
		 min={subplot.ydomain.min_range[0]}
		 max={subplot.ydomain.max_range[1]}
		 step={subplot.ydomain.step}
		 id="subplot_{subplot.subplot_id}_yaxismax"
		 value={subplot.ydomain.default[1]}
		 oninput={ (e) => { set_ydomain(e, subplot_index, 'max') } }/>


	{#each subplot.plot_elements as plotElement, plot_element_index}
 		<PlotElementForm {subplot} {plotElement} {subplot_index} {plot_element_index}/>
 	{/each}
{/if} <!-- visible -->

<style>
	h3{
		text-align: left;
		font-size: 12pt;
	}
</style>
